# AUTOGENERATED! DO NOT EDIT! File to edit: nbs/00a_inferfaces.ipynb (unless otherwise specified).

__all__ = ['BaseCFExplanationModule', 'LocalCFExplanationModule']

# Cell
from .import_essentials import *
from .datasets import TabularDataModule
from copy import deepcopy

# Cell
class BaseCFExplanationModule(ABC):
    cat_arrays = []
    cat_idx = 0

    @property
    @abstractmethod
    def name(self):
        pass

    @abstractmethod
    def generate_cfs(
        self,
        X: chex.ArrayBatched,
        pred_fn: Optional[Callable] = None,
        params: Optional[hk.Params] = None,
        rng_key: Optional[random.PRNGKey] = None
    ) -> chex.ArrayBatched:
        pass

    def update_cat_info(self, data_module: TabularDataModule):
        self.cat_arrays = deepcopy(data_module.cat_arrays)
        self.cat_idx = data_module.cat_idx

    # @abstractmethod
    # def generate_cf_results(
    #     self,
    #     dm: TabularDataModule,
    #     pred_fn: Optional[Callable] = None) -> CFExplanationResults:
    #     pass

# Cell
class LocalCFExplanationModule(BaseCFExplanationModule):
    pred_fn: Callable[[jnp.DeviceArray], jnp.DeviceArray]